
SOFTWARE_REPOSITORY = 'http://bootsrv.infinidat.com/clientapps'


from urllib import urlretrieve
from tempfile import mkstemp
from os import remove, close
from infi.pyutils.contexts import contextmanager
from fabric.api import run
from logging import getLogger

logger = getLogger("download")

@contextmanager
def tempfile_context(remove_at_exit=True):
    (fd, path) = mkstemp()
    close(fd)
    try:
        yield path
    finally:
        if remove_at_exit:
            remove(path)

@contextmanager
def download_file_from_repository(filename, repository=SOFTWARE_REPOSITORY):
    url = '/'.join([repository, filename])
    logger.debug('downloading {}'.format(url))
    with tempfile_context() as path:
        urlretrieve(url, path)
        logger.debug('download complete')
        yield path

def download_file_from_repository_on_remote_host(filename, repository=SOFTWARE_REPOSITORY):
    url = '/'.join([repository, filename])
    logger.debug('downloading {}'.format(url))
    run("rm -f {}".format(filename))
    run("wget --no-check-certificate {}".format(url))
