import re
from infi.vendata.jslave.fabric.utils import print_result
from fabric.api import cd, put, run, abort, settings, task, puts
from ..utils import user_context

SLMGR_PATH = r"cscript c:\\\\windows\\\\system32\\\\slmgr.vbs"

@task
@print_result
def verify():
    with user_context():
        from ..utils import determine_platform
        from ..utils.windows import is_windows_2003_or_xp
        if determine_platform() != "windows":
            return True
        if is_windows_2003_or_xp():
            return True
        output = run(SLMGR_PATH + " /dli")
        partial_key, status = re.search("Partial Product Key: (\S+)\s+License Status: (\S+)", output).groups()
        puts("Activation Status: {} {}".format(partial_key, status))
        return status == "Licensed"

@task
def install():
    # TODO for windows 2008s without a valid key:
    # run(SLMGR_PATH + " /ipk PQRFF-JFM87-Q94TP-F7Q3X-RKJVR")
    with user_context():
        run(SLMGR_PATH + " /ato")
