from infi.vendata.jslave.fabric.utils import print_result
from fabric.api import cd, put, run, abort, settings, task
from ...download import download_file_from_repository as download
from ..utils import user_context, reconnect, determine_platform, windows

VALUE = r"C:\Cygwin\home\Administrator"

def is_home_environment_variable_set_in_registry():
    return VALUE in get_home_environment_variable_from_registry()

@task
@print_result
def verify():
      return determine_platform() not in ["windows"] or is_home_environment_variable_set_in_registry()

def get_home_environment_variable_from_registry():
    with user_context(), settings(warn_only=True):
        query = run("{} query '{}' /v HOME".format(windows.REG, windows.HKCU_ENVIRON_REG_KEY))
        value = windows._extract_value_from_reg_query_output(query.stdout)
    return value

def set_home_environment_variable_in_registry():
    with user_context():
        stformat = "{} add '{}' /f /v HOME /t REG_EXPAND_SZ /d '{}'"
        run(stformat.format(windows.REG, windows.HKCU_ENVIRON_REG_KEY, VALUE), shell=False)

@task
def install():
    with user_context():
        if determine_platform() not in ["windows"]:
            return
    set_home_environment_variable_in_registry()
