from infi.vendata.jslave.fabric.utils import print_result
from fabric.api import settings, env, task
from ..utils import user_context, get_and_put_file
from json_rest import JSONRestSender

class GitHub(object):
    def __init__(self):
        super(GitHub, self).__init__()
        self._github = JSONRestSender("https://api.github.com")
        self._github.set_basic_authorization("jenkins-infinidat", "bWOUDdPwpsUQOpEPcaD1u7dIKm")

    def get_keys(self):
        from itertools import count
        res = []
        for page in count(1):
            page_data = self._github.get("/user/keys?page={}&per_page=100".format(page))
            res.extend(page_data)
            if len(page_data) != 100:
                break
        return res

    def get_matching_keys(self, key):
        return [item for item in self.get_keys() if key == item['key']]

    def has_key(self, key):
        return bool(len(self.get_matching_keys(key)))

    def remove_key(self, key):
        _ = [self._github.delete("/user/keys/{}".format(item['id'])) for item in self.get_matching_keys(key)]

    def set_key(self, key):
        title = "{}@{}".format(env.user, env.host_string)
        for item in [item for item in self.get_keys() if item['title'] == title]:
            self._github.delete("/user/keys/{}".format(item['id']))
        self._github.post("/user/keys", data=dict(title=title, key=key))

def get_key():
    with get_and_put_file(".ssh/id_rsa.pub") as local_path:
        with open(local_path) as fd:
            public_key = ' '.join(fd.read().split(' ')[0:2])
    return public_key

@task
@print_result
def verify():
    github = GitHub()
    with user_context(), settings(warn_only=True):
        key = get_key()
        return github.has_key(key)

@task
def install():
    github = GitHub()
    with user_context(), settings(warn_only=True):
        key = get_key()
        if github.has_key(key):
            github.remove_key(key)
        github.set_key(key)
