from ..utils import user_context, is_solaris, get_and_put_file, reconnect_after
from fabric.api import task, run, settings
from infi.vendata.jslave.fabric.utils import print_result
from .. import reboot

@task
@print_result
def verify():
    with user_context():
        if not is_solaris():
            return True
        return run("echo ~").stdout.strip("\n") == "/root"

@task
@reconnect_after
def install():
    with user_context():
        if not is_solaris():
            return
        with get_and_put_file('/etc/passwd') as local_path:
            with open(local_path, 'rb') as fd:
                content = fd.read()
            with open(local_path, 'wb') as fd:
                fd.write(content.replace('Super-User:/', 'Super-User:/root'))
        with settings(warn_only=True):
            run("mkdir /root")
