from infi.vendata.jslave.fabric.utils import print_result
from fabric.api import task, run, settings
from infi.vendata.jslave.fabric.utils.easy_install import EasyInstall
from ..utils import user_context

@task
@print_result
def verify():
    with user_context(), settings(warn_only=True):
        from infi.pypi_manager import DjangoPyPI
        from ..utils import determine_platform
        # case-sensitivity issues with djangopypi require this hack
        latest_version = DjangoPyPI("http://pypi01.infinidat.com").get_latest_version("infi.vendata.jslave")
        return latest_version in run("python -c 'from infi.vendata.jslave.__version__  import __version__; print __version__'")

@task
def install():
    EasyInstall("infi.vendata.jslave", "jfab").install()
    EasyInstall("Fabric").install()

