""" Workaround empty ca-certificates file as seen in HOSTDEV-1200 """

from fabric.api import cd, put, run, abort, settings, task, puts
from infi.vendata.jslave.fabric.utils import print_result, user_context, get_tempfile
import os


REMOTE_PATH = "/etc/ssl/certs/ca-certificates.crt"


@task
@print_result
def verify():
    with user_context():
        from ..utils import determine_platform
        from ..utils.linux import determine_distribution
        if determine_platform() != "linux" or determine_distribution()[0] != "ubuntu":
            return True
        with get_tempfile(REMOTE_PATH) as local_path:
            with open(local_path) as fd:
                data = fd.read()
            return len(data) > 0

@task
def install():
    local_path = os.path.join(os.path.dirname(__file__), os.path.basename(REMOTE_PATH))
    with user_context():
        put(local_path, REMOTE_PATH)