from infi.vendata.jslave.fabric.utils import print_result
from fabric.api import cd, put, run, abort, settings, task
from fabric.contrib.files import exists
from ...download import download_file_from_repository_on_remote_host as download
from ..utils import user_context, is_windows
from ..path import add_to_windows_path
import os

SYSINTENALS_PATH = r"C:\Sysinternals"
SYSINTENALS_PATH_IN_CYGWIN = "/cygdrive/c/Sysinternals"

@task
@print_result
def verify():
    with user_context():
        if not is_windows():
            return True
        return exists(SYSINTENALS_PATH_IN_CYGWIN)

@task
def install():
    with user_context():
        if not is_windows():
            return

        for zip_path in ['SysinternalsSuite.zip', 'depends22_x86.zip']:
            download(zip_path)
            run("unzip -o {} -d {}".format(zip_path, SYSINTENALS_PATH_IN_CYGWIN))
            run("rm {}".format(zip_path))

        add_to_windows_path(SYSINTENALS_PATH, SYSINTENALS_PATH_IN_CYGWIN)