from fabric.api import cd, put, run, abort, settings, task
from ...download import download_file_from_repository_on_remote_host as download

HOTFIX_URI = "hotfixes/KB2794119/"

hotfix_dict = {
    ("5.2", "x64"): "WindowsServer2003.WindowsXP-KB2794119-x64-ENU.exe",
    ("5.2", "x86"): "WindowsServer2003-KB2794119-x86-ENU.exe",
    ("6.0", "x64"): "Windows6.0-KB2794119-x64.msu",
    ("6.0", "x86"): "Windows6.0-KB2794119-x86.msu",
    ("6.1", "x64"): "Windows6.1-KB2794119-x64.msu",
    ("6.2", "x64"): "Windows8-RT-KB2794119-x64.msu",
}

def get_hotfix():
    from infi.vendata.jslave.fabric.utils.windows import get_nt_version
    from infi.vendata.jslave.fabric.utils import determine_architecture
    nt_version_and_arch = (get_nt_version(), determine_architecture(True))
    return hotfix_dict.get(nt_version_and_arch)

def install_windows():
    hotfix = get_hotfix()
    if hotfix is None:
        return
    download(HOTFIX_URI + hotfix)
    run("chmod 777 {}".format(hotfix))
    with settings(warn_only=True):
        if hotfix.endswith(".exe"):
            run("./{} /quiet".format(hotfix))
        else:
            run("wusa.exe /quiet ./{}".format(hotfix))
    run("rm {}".format(hotfix))