from fabric.api import cd, put, run, abort, settings, task
from infi.vendata.jslave.fabric.utils import print_result
from ..utils import user_context

def get_module():
    with user_context():
        from ..utils import determine_platform
        if determine_platform() in ["linux", ]:
            from . import linux
            return linux
        elif determine_platform() in ["windows", ]:
            from . import windows
            return windows
        else:
            abort("unsupported platform")

@task
@print_result
def verify():
    with user_context():
        return get_module().verify()

@task
def install():
    with user_context():
        return get_module().install()
