from fabric.api import cd, put, run, abort, settings, task
from ...download import download_file_from_repository_on_remote_host
from ..utils import untar

ARCHIVE_NAME = "VMwareTools-9.0.5-1283433.tar.gz"

def verify():
    with settings(warn_only=True):
        return "/usr/sbin/vmtoolsd" in run("ps x | grep vmtoolsd")

def install():
    download_file_from_repository_on_remote_host("VMWareTools/" + ARCHIVE_NAME)
    untar(ARCHIVE_NAME)
    with cd("vmware-tools-distrib"):
        with settings(warn_only=True):
            run("./vmware-install.pl --default")
    run("rm {}".format(ARCHIVE_NAME))
    run("rm -rf vmware-tools-distrib")

if __name__ == '__main__':
    install()
