from fabric.api import cd, put, run, abort, settings, task
from ...download import download_file_from_repository_on_remote_host

ARCHIVE_NAME = "VMware-tools-9.0.5.25843-{}.exe"

def verify():
    with settings(warn_only=True):
        return "RUNNING" in run("sc query VMTools")

def install():
    from ..utils import determine_architecture
    import os
    arch = determine_architecture(True)
    base_name = ARCHIVE_NAME.format(arch)
    download_file_from_repository_on_remote_host("VMWareTools/" + base_name)
    run("chmod 777 {}".format(base_name))
    run("easy_install -U infi.run_as")
    with settings(warn_only=True):
        run("run_as Administrator Xsignnet1 {} /s /v/qn REBOOT=ReallySuppress".format(base_name))
    run("rm {}".format(base_name))
