from fabric.api import run, task
from ...download import download_file_from_repository_on_remote_host
from infi.vendata.jslave.fabric.utils import print_result

def _install_winpty():
    package_name = "winpty-windows-{}.zip".format("x86" if run("uname -m") == "i686" else "x64")
    download_file_from_repository_on_remote_host(package_name)
    run("unzip {} -d /bin".format(package_name))


@task
def install():
    from ..utils import determine_platform, user_context
    from ..utils.linux import determine_distribution
    with user_context():
        if determine_platform() == "windows":
            _install_winpty()
    return True


@task
@print_result
def verify():
    from ..utils import determine_platform, user_context
    from fabric.contrib.files import exists
    with user_context():
        if determine_platform() == "windows":
            return exists('/bin/console.exe')
        else:
            return True
