
class Jenkins(object):
    def __init__(self, base_url):
        super(Jenkins, self).__init__()
        self.base_url = base_url
        pass

    def eval_uri(self, uri):
        from urllib2 import urlopen
        return eval(urlopen('//'.join([self.base_url, uri])).read())

    def get_computers(self):
        return self.eval_uri("computer/api/python")["computer"]

    def get_slaves(self):
        return filter(lambda computer: computer.is_slave(), [Computer(_dict) for _dict in self.get_computers()])

    def get_master_computer(self):
        return filter(lambda computer: computer.is_master(), [Computer(_dict) for _dict in self.get_computers()])[0]

    def __repr__(self):
        return "Jenkins URL {}, {}".format(self.base_url, repr(self.get_master_computer()))

class Computer(object):
    def __init__(self, _dict):
        self._dict = _dict

    def get_name(self):
        return self._dict["displayName"]

    def get_operating_system(self):
        return self._dict["monitorData"]["hudson.node_monitors.ArchitectureMonitor"]

    def get_architecture(self):
        """:returns: x86 or i386 or amd64"""
        import re
        pattern = re.compile(".*\(([A-Za-z0-9]+)\).*")
        return pattern.match(self.get_operating_system()).groups()[0]

    def is_windows(self):
        return "Windows" in self.get_operating_system()

    def is_linux(self):
        return "Linux" in self.get_operating_system()

    def is_x64(self):
        return "amd64" == self.get_architecture()

    def is_x86(self):
        return not self.is_x64()

    def is_master(self):
        return self.get_name() == "master"

    def is_slave(self):
        return not self.is_master()

    def __repr__(self):
        return "Jeknins Computer: {}, {}".format(self.get_name(), self.get_operating_system())
